diff --git a/sound/drivers/upisnd/upisnd_midi.c b/sound/drivers/upisnd/upisnd_midi.c
new file mode 100644
index 000000000000..b7fea8227bf6
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_midi.c
@@ -0,0 +1,337 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "upisnd_common.h"
+
+static int upisnd_midi_output_open(struct snd_rawmidi_substream *substream)
+{
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	mutex_lock(&instance->midi.out_lock);
+	instance->midi.midi_output = substream;
+	mutex_unlock(&instance->midi.out_lock);
+	return 0;
+}
+
+static void upisnd_midi_output_drain(struct snd_rawmidi_substream *substream);
+
+static int upisnd_midi_output_close(struct snd_rawmidi_substream *substream)
+{
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	printd("Close: draining output");
+	upisnd_midi_output_drain(substream);
+	printd("Close: setting to null");
+	mutex_lock(&instance->midi.out_lock);
+	instance->midi.midi_output = NULL;
+	mutex_unlock(&instance->midi.out_lock);
+	return 0;
+}
+
+static void upisnd_midi_output_trigger(struct snd_rawmidi_substream *substream, int up)
+{
+	if (up == 0)
+		return;
+
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	if (!delayed_work_pending(&instance->midi.midi_out_handler))
+		queue_delayed_work(instance->work_queue, &instance->midi.midi_out_handler, 0);
+}
+
+static void upisnd_midi_output_drain(struct snd_rawmidi_substream *substream)
+{
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	printd("Begin draining!");
+
+	do {
+		printd("Before flush");
+		while (delayed_work_pending(&instance->midi.midi_out_handler))
+			flush_delayed_work(&instance->midi.midi_out_handler);
+		printd("Flushed");
+	} while (!snd_rawmidi_transmit_empty(substream));
+
+	printd("Done!");
+}
+
+static int upisnd_midi_input_open(struct snd_rawmidi_substream *substream)
+{
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	mutex_lock(&instance->midi.in_lock);
+	instance->midi.midi_input = substream;
+	mutex_unlock(&instance->midi.in_lock);
+	return 0;
+}
+
+static int upisnd_midi_input_close(struct snd_rawmidi_substream *substream)
+{
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	mutex_lock(&instance->midi.in_lock);
+	instance->midi.midi_input = NULL;
+	mutex_unlock(&instance->midi.in_lock);
+	return 0;
+}
+
+static void upisnd_midi_input_trigger(struct snd_rawmidi_substream *substream, int up)
+{
+	if (up == 0)
+		return;
+
+	struct upisnd_instance *instance = substream->rmidi->private_data;
+
+	if (!work_pending(&instance->midi.midi_in_handler))
+		queue_work(instance->work_queue, &instance->midi.midi_in_handler);
+}
+
+static const struct snd_rawmidi_ops upisnd_midi_output_ops = {
+	.open = upisnd_midi_output_open,
+	.close = upisnd_midi_output_close,
+	.trigger = upisnd_midi_output_trigger,
+	.drain = upisnd_midi_output_drain,
+};
+
+static const struct snd_rawmidi_ops upisnd_midi_input_ops = {
+	.open = upisnd_midi_input_open,
+	.close = upisnd_midi_input_close,
+	.trigger = upisnd_midi_input_trigger,
+};
+
+static void upisnd_get_port_info(struct snd_rawmidi *rmidi,
+				 int number,
+				 struct snd_seq_port_info *seq_port_info)
+{
+	seq_port_info->type =
+		SNDRV_SEQ_PORT_TYPE_MIDI_GENERIC |
+		SNDRV_SEQ_PORT_TYPE_HARDWARE |
+		SNDRV_SEQ_PORT_TYPE_PORT;
+	seq_port_info->midi_voices = 0;
+}
+
+static const struct snd_rawmidi_global_ops upisnd_midi_ops = {
+	.get_port_info = upisnd_get_port_info,
+};
+
+static void upisnd_midi_in_handler(struct work_struct *work)
+{
+	int n, err;
+
+	printd("In handler");
+	struct upisnd_instance *instance = container_of(work,
+							struct upisnd_instance,
+							midi.midi_in_handler);
+
+	mutex_lock(&instance->midi.in_lock);
+	if (!instance->midi.midi_input)
+		goto cleanup;
+
+	u8 data[512];
+
+	n = kfifo_out_peek(&instance->midi.midi_in_fifo, data, sizeof(data));
+	err = snd_rawmidi_receive(instance->midi.midi_input, data, n);
+
+	if (err < 0)
+		printe("snd_rawmidi_receive failed! (%d)", err);
+
+	if (err > 0) {
+		printd("Received %d MIDI bytes", err);
+		instance->midi.rx_cnt += err;
+	}
+
+	kfifo_skip_count(&instance->midi.midi_in_fifo, err);
+
+	if (!kfifo_is_empty(&instance->midi.midi_in_fifo) &&
+	    !work_pending(&instance->midi.midi_in_handler)) {
+		queue_work(instance->work_queue, &instance->midi.midi_in_handler);
+	}
+cleanup:
+	mutex_unlock(&instance->midi.in_lock);
+	printd("Done");
+}
+
+static void upisnd_midi_out_handler(struct work_struct *work)
+{
+	printd("Out handler");
+	struct upisnd_instance *instance = container_of(work,
+							struct upisnd_instance,
+							midi.midi_out_handler.work);
+
+	mutex_lock(&instance->midi.out_lock);
+	printd("midi_output = %p", instance->midi.midi_output);
+	if (!instance->midi.midi_output)
+		goto cleanup;
+
+	enum { MIDI_MILLI_BYTES_PER_JIFFY = 3125000 / HZ };
+	enum { MIDI_MAX_OUTPUT_BUFFER_SIZE_IN_MILLIBYTES = 4096000 };
+
+	unsigned int now = jiffies;
+	unsigned int millibytes_became_available = (MIDI_MILLI_BYTES_PER_JIFFY) *
+		(now - instance->midi.last_midi_output_at);
+
+	instance->midi.output_buffer_used_in_millibytes =
+		instance->midi.output_buffer_used_in_millibytes <= millibytes_became_available ?
+		0 : instance->midi.output_buffer_used_in_millibytes - millibytes_became_available;
+	instance->midi.last_midi_output_at = now;
+
+	unsigned int output_buffer_available = (MIDI_MAX_OUTPUT_BUFFER_SIZE_IN_MILLIBYTES -
+		instance->midi.output_buffer_used_in_millibytes) / 1000;
+
+	u8 buffer[UPISND_MAX_PACKET_LENGTH - 1];
+	int n, batch, err;
+
+	printd("Available: %u", output_buffer_available);
+
+	for (batch = 0; batch < 3; ++batch) {
+		if (output_buffer_available == 0)
+			break;
+
+		n = snd_rawmidi_transmit_peek(instance->midi.midi_output,
+					      buffer,
+					      min(output_buffer_available, sizeof(buffer)));
+
+		if (n > 0) {
+			printd("Peeked: %d (batch %d)", n, batch);
+			err = upisnd_comm_send_midi(instance, buffer, (unsigned int)n);
+			if (err < 0) {
+				printe("Error occurred when sending MIDI data over I2C! (%d)", n);
+				goto cleanup;
+			}
+			snd_rawmidi_transmit_ack(instance->midi.midi_output, n);
+
+			instance->midi.tx_cnt += n;
+			instance->midi.output_buffer_used_in_millibytes += n * 1000;
+			output_buffer_available -= n;
+		} else if (n < 0) {
+			printe("snd_rawmidi_transmit_peek returned error %d!", n);
+			goto cleanup;
+		} else {
+			break;
+		}
+	}
+
+	printd("Checking if empty %p", instance->midi.midi_output);
+	if (!snd_rawmidi_transmit_empty(instance->midi.midi_output)) {
+		unsigned int delay = 0;
+
+		if (instance->midi.output_buffer_used_in_millibytes >
+		    MIDI_MAX_OUTPUT_BUFFER_SIZE_IN_MILLIBYTES - 127000)
+			delay = 127000 / MIDI_MILLI_BYTES_PER_JIFFY;
+		printd("Queue more work after %u jiffies", delay);
+		queue_delayed_work(instance->work_queue, &instance->midi.midi_out_handler, delay);
+	}
+
+cleanup:
+	mutex_unlock(&instance->midi.out_lock);
+	printd("Done");
+}
+
+static void upisnd_proc_stat_show(struct snd_info_entry *entry, struct snd_info_buffer *buffer)
+{
+	const unsigned int *d = entry->private_data;
+
+	snd_iprintf(buffer, "%u\n", *d);
+}
+
+int upisnd_midi_init(struct upisnd_instance *instance)
+{
+	int err;
+
+	mutex_init(&instance->midi.in_lock);
+	mutex_init(&instance->midi.out_lock);
+
+	err = snd_card_ro_proc_new(instance->sound_card.snd_card, "tx", &instance->midi.tx_cnt,
+				   upisnd_proc_stat_show);
+	err = snd_card_ro_proc_new(instance->sound_card.snd_card, "rx", &instance->midi.rx_cnt,
+				   upisnd_proc_stat_show);
+
+	err = snd_rawmidi_new(instance->sound_card.snd_card,
+			      "pisoundmicro", 0, 1, 1,
+			      &instance->midi.rawmidi);
+
+	struct snd_rawmidi *rawmidi = instance->midi.rawmidi;
+
+	if (err < 0) {
+		printe("snd_rawmidi_new failed: %d\n", err);
+		return err;
+	}
+
+	strscpy(rawmidi->name, "pisound-micro ", sizeof(rawmidi->name));
+	strcat(rawmidi->name, instance->ctrl.serial);
+
+	rawmidi->info_flags =
+		SNDRV_RAWMIDI_INFO_OUTPUT |
+		SNDRV_RAWMIDI_INFO_INPUT |
+		SNDRV_RAWMIDI_INFO_DUPLEX;
+
+	rawmidi->ops = &upisnd_midi_ops;
+
+	rawmidi->private_data = instance;
+
+	snd_rawmidi_set_ops(rawmidi, SNDRV_RAWMIDI_STREAM_OUTPUT, &upisnd_midi_output_ops);
+
+	snd_rawmidi_set_ops(rawmidi, SNDRV_RAWMIDI_STREAM_INPUT, &upisnd_midi_input_ops);
+
+	INIT_KFIFO(instance->midi.midi_in_fifo);
+	instance->midi.last_midi_output_at = jiffies;
+
+	INIT_WORK(&instance->midi.midi_in_handler, upisnd_midi_in_handler);
+	INIT_DELAYED_WORK(&instance->midi.midi_out_handler, upisnd_midi_out_handler);
+
+	return 0;
+}
+
+void upisnd_midi_uninit(struct upisnd_instance *instance)
+{
+	if (!instance->midi.rawmidi)
+		return;
+
+	cancel_work_sync(&instance->midi.midi_in_handler);
+	cancel_delayed_work_sync(&instance->midi.midi_out_handler);
+
+	instance->midi.rawmidi->private_data = NULL;
+
+	instance->midi.rawmidi = NULL;
+	mutex_lock(&instance->midi.in_lock);
+	instance->midi.midi_input = NULL;
+	mutex_unlock(&instance->midi.in_lock);
+	mutex_lock(&instance->midi.out_lock);
+	instance->midi.midi_output = NULL;
+	mutex_unlock(&instance->midi.out_lock);
+
+	kfifo_free(&instance->midi.midi_in_fifo);
+}
+
+void upisnd_handle_midi_data(struct upisnd_instance *instance, const uint8_t *data, unsigned int n)
+{
+	printd("%p, %u", instance, n);
+	if (n == 0)
+		return;
+
+	int i;
+
+	for (i = 0; i < n; ++i) {
+		kfifo_put(&instance->midi.midi_in_fifo, data[i]);
+		printd("Received MIDI %02x", data[i]);
+	}
+
+	if (!work_pending(&instance->midi.midi_in_handler))
+		queue_work(instance->work_queue, &instance->midi.midi_in_handler);
+	printd("Done");
+}
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_midi.h b/sound/drivers/upisnd/upisnd_midi.h
new file mode 100644
index 000000000000..0a4678e17e07
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_midi.h
@@ -0,0 +1,47 @@
+/* SPDX-License-Identifier: GPL-2.0-only */
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef UPISOUND_MIDI_H
+#define UPISOUND_MIDI_H
+
+struct upisnd_instance;
+
+struct upisnd_midi {
+	// in_lock protects the input substream.
+	struct mutex                      in_lock;
+	// out_lock protects the output substream.
+	struct mutex                      out_lock;
+	struct work_struct                midi_in_handler;
+	struct delayed_work               midi_out_handler;
+
+	struct snd_rawmidi                *rawmidi;
+	struct snd_rawmidi_substream      *midi_input;
+	struct snd_rawmidi_substream      *midi_output;
+	DECLARE_KFIFO(midi_in_fifo, uint8_t, 4096);
+	unsigned int                      last_midi_output_at;
+	unsigned int                      output_buffer_used_in_millibytes;
+	unsigned int                      tx_cnt;
+	unsigned int                      rx_cnt;
+};
+
+int upisnd_midi_init(struct upisnd_instance *instance);
+void upisnd_midi_uninit(struct upisnd_instance *instance);
+
+void upisnd_handle_midi_data(struct upisnd_instance *instance, const uint8_t *data, unsigned int n);
+
+#endif // UPISOUND_MIDI_H
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_module.c b/sound/drivers/upisnd/upisnd_module.c
new file mode 100644
index 000000000000..ef545313c0c2
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_module.c
@@ -0,0 +1,273 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "upisnd_common.h"
+
+void upisnd_instance_release(struct kref *kref)
+{
+	struct upisnd_instance *instance = container_of(kref, struct upisnd_instance, refcount);
+
+	if (instance->codec_dev) {
+		put_device(instance->codec_dev);
+		instance->codec_dev = NULL;
+	}
+
+	if (instance->ctrl_dev) {
+		instance->ctrl_dev->platform_data = NULL;
+		put_device(instance->ctrl_dev);
+		instance->ctrl_dev = NULL;
+	}
+
+	if (instance->sound_card.dev) {
+		snd_soc_unregister_card(&instance->sound_card);
+		memset(&instance->sound_card, 0, sizeof(instance->sound_card));
+	}
+
+	if (instance->work_queue) {
+		flush_workqueue(instance->work_queue);
+		destroy_workqueue(instance->work_queue);
+		instance->work_queue = NULL;
+	}
+
+	printd("Releasing instance %p", instance);
+	kfree(instance);
+}
+
+static int of_dev_node_match(struct device *dev, const void *data)
+{
+	return dev->of_node == data;
+}
+
+static int upisnd_probe(struct platform_device *pdev)
+{
+	printd("Load %p", pdev);
+
+	int err = 0;
+	struct device_node *node;
+	struct device_node *i2c_node;
+	struct device *dev;
+
+	struct upisnd_instance *instance = pdev->dev.platform_data;
+
+	if (!instance) {
+		instance = kzalloc(sizeof(*instance), GFP_KERNEL);
+
+		if (!instance) {
+			printe("Failed to allocate instance!");
+			err = -ENOMEM;
+			goto cleanup;
+		}
+		kref_init(&instance->refcount);
+
+		pdev->dev.platform_data = instance;
+		instance->pdev = pdev;
+
+		init_rwsem(&instance->rw_gpio_config_sem);
+
+		instance->work_queue = create_singlethread_workqueue("upisnd_workqueue");
+		if (!instance->work_queue) {
+			printe("Failed creating single thread work queue!");
+			err = -ENOMEM;
+			goto cleanup;
+		}
+	}
+
+	node = pdev->dev.of_node;
+	if (!node) {
+		printe("Device node not found!");
+		err = -ENODEV;
+		goto cleanup;
+	}
+
+	i2c_node = of_parse_phandle(node, "ctrl", 0);
+	if (!i2c_node) {
+		printe("Failed to read 'ctrl' node!");
+		err = -ENODEV;
+		goto cleanup;
+	}
+
+	dev = bus_find_device(&i2c_bus_type, NULL, i2c_node, of_dev_node_match);
+	of_node_put(i2c_node);
+
+	if (!dev) {
+		printe("Failed to find 'ctrl' device (%pOF)!", i2c_node);
+		err = -ENODEV;
+		goto cleanup;
+	}
+
+	bool got_ref = false;
+
+	if (!dev->platform_data) {
+		kref_get(&instance->refcount);
+		dev->platform_data = instance;
+		got_ref = true;
+	}
+	instance->ctrl_dev = dev;
+
+	if (instance->ctrl.serial[0] == '\0') {
+		printd("Deferring probe until serial is retrieved!");
+		return -EPROBE_DEFER;
+	}
+
+	i2c_node = of_parse_phandle(node, "codec", 0);
+
+	if (!i2c_node) {
+		printe("Failed to read 'codec' node!");
+		err = -ENODEV;
+		goto cleanup;
+	}
+
+	dev = bus_find_device(&i2c_bus_type, NULL, i2c_node, of_dev_node_match);
+	of_node_put(i2c_node);
+
+	if (!dev) {
+		printe("Failed to find 'codec' device!");
+		err = -ENODEV;
+		goto cleanup;
+	}
+
+	instance->codec_dev = dev;
+
+	err = upisnd_sound_init(pdev, instance);
+	if (err != 0) {
+		if (err != -EPROBE_DEFER)
+			printe("Failed initializing sound card! (%d)", err);
+		goto cleanup;
+	}
+
+cleanup:
+	if (err != 0) {
+		if (err != -EPROBE_DEFER)
+			printe("Error %d!", err);
+
+		if (instance) {
+			if (got_ref) {
+				instance->ctrl_dev->platform_data = NULL;
+				kref_put(&instance->refcount, &upisnd_instance_release);
+			}
+
+			if (instance->codec_dev) {
+				put_device(instance->codec_dev);
+				instance->codec_dev = NULL;
+			}
+		}
+	}
+
+	return err;
+}
+
+static void upisnd_remove(struct platform_device *pdev)
+{
+	printd("Unload %p", pdev);
+	struct upisnd_instance *instance = dev_get_platdata(&pdev->dev);
+
+	kref_put(&instance->refcount, &upisnd_instance_release);
+	pdev->dev.platform_data = NULL;
+}
+
+static const struct of_device_id upisnd_of_match[] = {
+	{.compatible = "blokas,pisound-micro" },
+	{}
+};
+
+static const struct of_device_id upisnd_ctrl_of_match[] = {
+	{.compatible = "blokas,upisnd-ctrl" },
+	{}
+};
+
+static struct platform_driver upisnd_driver = {
+	.driver = {
+		.name = "snd-pisound-micro",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(upisnd_of_match),
+	},
+	.probe = upisnd_probe,
+	.remove = upisnd_remove,
+};
+
+static const struct i2c_device_id upisnd_ctrl_idtable[] = {
+	{ "blokas,upisnd-ctrl", 0 },
+	{}
+};
+
+static struct i2c_driver upisnd_ctrl_driver = {
+	.driver = {
+		.name = "snd-pisound-micro-ctrl",
+		.owner = THIS_MODULE,
+		.of_match_table = of_match_ptr(upisnd_ctrl_of_match),
+	},
+	.id_table = upisnd_ctrl_idtable,
+	.probe = upisnd_ctrl_probe,
+	.remove = upisnd_ctrl_remove,
+};
+
+static int upisnd_module_init(void)
+{
+	int err, progress = 0;
+
+	err = upisnd_comm_module_init();
+	if (err != 0)
+		goto cleanup;
+
+	++progress;
+	err = platform_driver_register(&upisnd_driver);
+	if (err != 0)
+		goto cleanup;
+
+	++progress;
+	err = i2c_add_driver(&upisnd_ctrl_driver);
+	if (err != 0)
+		goto cleanup;
+
+cleanup:
+	if (err) {
+		printe("Error %d occurred, progress: %d", err, progress);
+		switch (progress) {
+		case 2:
+			i2c_del_driver(&upisnd_ctrl_driver);
+			fallthrough;
+		case 1:
+			platform_driver_unregister(&upisnd_driver);
+			fallthrough;
+		case 0:
+			// No comm uninit.
+			fallthrough;
+		default:
+			break;
+		}
+	}
+
+	return err;
+}
+
+static void upisnd_module_exit(void)
+{
+	i2c_del_driver(&upisnd_ctrl_driver);
+	platform_driver_unregister(&upisnd_driver);
+}
+
+module_init(upisnd_module_init);
+module_exit(upisnd_module_exit);
+
+MODULE_DEVICE_TABLE(of, upisnd_of_match);
+MODULE_DEVICE_TABLE(of, upisnd_ctrl_of_match);
+MODULE_DEVICE_TABLE(i2c, upisnd_ctrl_idtable);
+
+MODULE_AUTHOR("Giedrius Trainavi\xc4\x8dius <giedrius@blokas.io>");
+MODULE_DESCRIPTION("Audio, MIDI & I/O Driver for Pisound Micro, https://blokas.io/");
+MODULE_LICENSE("GPL v2");
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_pins.c b/sound/drivers/upisnd/upisnd_pins.c
new file mode 100644
index 000000000000..8e3e9bac6bed
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_pins.c
@@ -0,0 +1,113 @@
+// SPDX-License-Identifier: GPL-2.0-only
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "upisnd_common.h"
+
+struct upisnd_pin_def_t {
+	const char                   *name;
+	upisnd_pin_capability_mask_t capabilities;
+};
+
+static const struct upisnd_pin_def_t upisnd_pins[UPISND_PIN_COUNT] = {
+	{ "A27", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "A28", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "A29", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "A30", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "A31", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "A32", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "B03", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B04", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B05", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B06", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B07", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B08", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B09", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B10", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	// Pull down is not available in MCU revisions A, B, C, D, E. F and G are not affected.
+	{ "B11", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	// Pull down is not available in MCU revisions A, B, C, D, E. F and G are not affected.
+	{ "B12", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B13", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B14", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B15", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B16", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B17", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B18", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ENCODER },
+	{ "B23", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B24", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B25", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B26", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B27", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B28", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B29", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B30", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B31", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B32", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B33", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B34", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY | UPISND_PIN_CAP_ANALOG_IN },
+	{ "B37", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "B38", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+	{ "B39", UPISND_PIN_CAP_GPIO | UPISND_PIN_CAP_MIDI_ACTIVITY },
+};
+
+upisnd_pin_t upisnd_name_to_pin(const char *name)
+{
+	if (!name || strlen(name) != 3 || !isdigit(name[1]) || !isdigit(name[2]))
+		return UPISND_PIN_INVALID;
+
+	char sanitized[4];
+
+	switch (*name) {
+	case 'a': case 'A':
+		sanitized[0] = 'A';
+		break;
+	case 'b': case 'B':
+		sanitized[0] = 'B';
+		break;
+	default:
+		return UPISND_PIN_INVALID;
+	}
+
+	memcpy(&sanitized[1], &name[1], 2);
+	sanitized[3] = '\0';
+
+	int i;
+
+	for (i = 0; i < ARRAY_SIZE(upisnd_pins); ++i) {
+		if (strcmp(sanitized, upisnd_pins[i].name) == 0)
+			return i;
+	}
+
+	return UPISND_PIN_INVALID;
+}
+
+const char *upisnd_pin_name(upisnd_pin_t pin)
+{
+	if (!upisnd_is_pin_valid(pin))
+		return "";
+
+	return upisnd_pins[pin].name;
+}
+
+int upisnd_check_caps(upisnd_pin_t pin, upisnd_pin_capability_mask_t mask)
+{
+	if (!upisnd_is_pin_valid(pin))
+		return -ENXIO;
+
+	return (upisnd_pins[pin].capabilities & mask) == mask ? 0 : -EINVAL;
+}
+
+/* vim: set ts=8 sw=8 noexpandtab: */
diff --git a/sound/drivers/upisnd/upisnd_pins.h b/sound/drivers/upisnd/upisnd_pins.h
new file mode 100644
index 000000000000..5f4b3a5660a3
--- /dev/null
+++ b/sound/drivers/upisnd/upisnd_pins.h
@@ -0,0 +1,67 @@
+/* SPDX-License-Identifier: GPL-2.0-only */
+/*
+ * Pisound Micro Linux kernel module.
+ * Copyright (C) 2017-2025  Vilniaus Blokas UAB, https://blokas.io/
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; version 2 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#ifndef UPISOUND_PINS_H
+#define UPISOUND_PINS_H
+
+enum { UPISND_NUM_GPIOS = 37 };
+
+enum upisnd_pin_e {
+	UPISND_PIN_A27, UPISND_PIN_A28, UPISND_PIN_A29, UPISND_PIN_A30,
+	UPISND_PIN_A31, UPISND_PIN_A32, UPISND_PIN_B03, UPISND_PIN_B04,
+	UPISND_PIN_B05, UPISND_PIN_B06, UPISND_PIN_B07, UPISND_PIN_B08,
+	UPISND_PIN_B09, UPISND_PIN_B10, UPISND_PIN_B11, UPISND_PIN_B12,
+	UPISND_PIN_B13, UPISND_PIN_B14, UPISND_PIN_B15, UPISND_PIN_B16,
+	UPISND_PIN_B17, UPISND_PIN_B18, UPISND_PIN_B23, UPISND_PIN_B24,
+	UPISND_PIN_B25, UPISND_PIN_B26, UPISND_PIN_B27, UPISND_PIN_B28,
+	UPISND_PIN_B29, UPISND_PIN_B30, UPISND_PIN_B31, UPISND_PIN_B32,
+	UPISND_PIN_B33, UPISND_PIN_B34, UPISND_PIN_B37, UPISND_PIN_B38,
+	UPISND_PIN_B39,
+
+	UPISND_PIN_COUNT,
+	UPISND_PIN_INVALID = UPISND_PIN_COUNT
+};
+
+typedef u8 upisnd_pin_t;
+
+static inline bool upisnd_is_pin_valid(upisnd_pin_t pin)
+{
+	return pin < UPISND_PIN_COUNT;
+}
+
+enum upisnd_pin_capability_flags_e {
+	UPISND_PIN_CAP_GPIO_DIR_INPUT  = 1 << 0,
+	UPISND_PIN_CAP_GPIO_DIR_OUTPUT = 1 << 1,
+	UPISND_PIN_CAP_GPIO_PULL_UP    = 1 << 2,
+	UPISND_PIN_CAP_GPIO_PULL_DOWN  = 1 << 3,
+	UPISND_PIN_CAP_GPIO            = UPISND_PIN_CAP_GPIO_DIR_INPUT |
+					 UPISND_PIN_CAP_GPIO_DIR_OUTPUT |
+					 UPISND_PIN_CAP_GPIO_PULL_UP |
+					 UPISND_PIN_CAP_GPIO_PULL_DOWN,
+	UPISND_PIN_CAP_ENCODER         = 1 << 4,
+	UPISND_PIN_CAP_ANALOG_IN       = 1 << 5,
+	UPISND_PIN_CAP_MIDI_ACTIVITY   = 1 << 6,
+};
+
+typedef u8 upisnd_pin_capability_mask_t;
+
+upisnd_pin_t upisnd_name_to_pin(const char *name);
+const char *upisnd_pin_name(upisnd_pin_t pin);
+int upisnd_check_caps(upisnd_pin_t pin, upisnd_pin_capability_mask_t mask);
+
+#endif // UPISOUND_PINS_H
+
+/* vim: set ts=8 sw=8 noexpandtab: */
